	.text
	.globl coth_switch
	.type coth_switch,@function
coth_switch:
	/* standard entry code for functions with local variables */
	pushl %ebp
	movl %esp, %ebp
	/* from this point on, we don't need %esp, so we can use it
        as a pointer to the data structure holding the source context */
	movl 8(%ebp), %esp
	/* we need 7 double words to store the registers */
	addl $28, %esp
	pushl %eax
	pushl %ebx
	pushl %ecx
	pushl %edx
	pushl %esi
	pushl %edi
	pushl %ebp

	/* now all registers are free, we can load them from the 
	destination context. */

	movl 12(%ebp), %esp
	popl %ebp
	popl %edi
	popl %esi
	popl %edx
	popl %ecx
	popl %ebx
	popl %eax

	/* now, ebp = ebp of the destination context. simply running
           leave, ret will store ebp back into esp and return. nice. */

	leave
	ret
	.size coth_switch, . - coth_switch
