#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <unistd.h>
#include <limits.h>
#include "coth.h"


coth_t *main_ctx;
coth_t *child_ctx;

void foo(int i)
{
      printf("C %d\n", i);
      coth_switch(child_ctx,main_ctx);
}

void child_func()
{
  int i;
  for(i=0;;i++)
   {
       foo(i);
   }
}

void args_func(int *a,int *b)
{
  *a= 5;
  *b= 6;

  coth_switch(child_ctx, main_ctx);
}


int main()
{
    int a,b;
    main_ctx= coth_main();
    child_ctx= coth_new(child_func, 4096);

    int i;
    for(i=0;i<20;i++)
    {
       printf("M %d\n", i);
       coth_switch(main_ctx, child_ctx);       
    }

    a=1; b=2;

    printf("entering child thread\n");
    child_ctx= coth_new(args_func, 8192);
    coth_arg(child_ctx, 1, &a);
    coth_arg(child_ctx, 2, &b);
    coth_switch(main_ctx, child_ctx);
    printf("exited child thread a= %d b= %d\n",a,b);

    return 0;
}
