#include <stdio.h>
#include <string.h>
#include <ctype.h>

void hexprint(const unsigned char *A, unsigned int len, 
             unsigned int offset, int width)
{
  int i;

  while(len)
  {
    printf("%0*x:", width, offset);
    for(i=0;i<16 && i<len;i++) printf(" %02x", A[i]);
    for(;i<16;i++) printf("   ");
    printf(" ");
    for(i=0;i<16 && i<len;i++)
      if (isprint(A[i])) printf("%c",A[i]);
      else printf(".");
    printf("\n");
    A+=i;
    len-=i;
    offset+= i;
  }
}
