#include <stdlib.h>
#include <string.h>
#include "cmdline.h"

static int ispc(char X)
{
  if (X>0 && X<=' ') return 1;
  if (X==127) return 1;
  return 0;
}

char** parse_cmd_line(char *inp)
{
   int N,i,spc;
   static char* foo[100];

   spc= 1; N= 0;
   for(i=0;inp[i];i++)
   {
     switch( 2*spc + ispc(inp[i]) )
     {
     case 2*1 + 0: // from a space char to non-space char
         N++;
         foo[N-1]= inp+i;
         spc=0;
         break;
     case 2*1 + 1:  // space to space, or nonspace to nonspace
     case 2*0 + 0:
         break;
     case 2*0 + 1:
         inp[i]= 0;
         spc= 1;
         break;
     }
   }
   if (N==0) return NULL;
   foo[N]= NULL;
   return foo;
}

